org.cpsolver.coursett.sectioning

## Class StudentSwapGenerator

- java.lang.Object
- - org.cpsolver.coursett.sectioning.StudentSwapGenerator

- All Implemented Interfaces:
    NeighbourSelection<Lecture,Placement>
  Direct Known Subclasses:
    RandomStudentSwap

      public class StudentSwapGenerator
      extends Object
      implements NeighbourSelection<Lecture,Placement>

  Generate student swaps. Rather than generating swaps at random, the class iterates between all classes and all conflicting students of each class and generate a random swap for each such student.
  Version:
    CourseTT 1.3 (University Course Timetabling)
    Copyright (C) 2017 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `StudentSwapGenerator()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Neighbour<Lecture,Placement>` | `generateSwap(TimetableModel model, Assignment<Lecture,Placement> assignment, Student student, Configuration config)`
    `void` | `init(Solver<Lecture,Placement> solver)` Criterion initialization
    `Neighbour<Lecture,Placement>` | `selectNeighbour(Assignment<Lecture,Placement> assignment, Lecture lecture)`
    `Neighbour<Lecture,Placement>` | `selectNeighbour(Solution<Lecture,Placement> solution)` select a neighbour of a given solution

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### StudentSwapGenerator

          public StudentSwapGenerator()

  - ### Method Detail

    - #### init

          public void init(Solver<Lecture,Placement> solver)

      Description copied from interface: `NeighbourSelection`
      Criterion initialization
      Specified by:
        `init` in interface `NeighbourSelection<Lecture,Placement>`
      Parameters:
        `solver` - current solver

    - #### selectNeighbour

          public Neighbour<Lecture,Placement> selectNeighbour(Solution<Lecture,Placement> solution)

      Description copied from interface: `NeighbourSelection`
      select a neighbour of a given solution
      Specified by:
        `selectNeighbour` in interface `NeighbourSelection<Lecture,Placement>`
      Parameters:
        `solution` - given solution
      Returns:
        a neighbour assignment

    - #### selectNeighbour

          public Neighbour<Lecture,Placement> selectNeighbour(Assignment<Lecture,Placement> assignment,
                                                              Lecture lecture)

    - #### generateSwap

          public Neighbour<Lecture,Placement> generateSwap(TimetableModel model,
                                                           Assignment<Lecture,Placement> assignment,
                                                           Student student,
                                                           Configuration config)